////////////////////////////////////////////////////////////////////////////////////////////////

// ڂ̏d݌WF

float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 offs = float2(ViewportSize.x / 8.0f, ViewportSize.y / 8.0f);

// _O^[Qbg̃NAl
float4 ClearColor = {0,0,0,0};
float ClearDepth  = 1.0;

// IWi̕`挋ʂL^邽߂̃_[^[Qbg
shared texture2D HalfToonMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {0.25,0.25};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D HalfToonSamp = sampler_state {
    texture = <HalfToonMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;
/*
// X̂ڂʂL^邽߂̃_[^[Qbg
texture2D ScnMap2 : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp2 = sampler_state {
    texture = <ScnMap2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};
*/
texture2D halfmap < string ResourceName = "TV.png"; >;
sampler2D halfSamp = sampler_state {
    texture = <halfmap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = WRAP;
    AddressV = WRAP;
};

////////////////////////////////////////////////////////////////////////////////////////////////
// Xڂ

struct VS_OUTPUT {
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT VS_pass1( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + float2(ViewportOffset.x, ViewportOffset.y);
    
    return Out;
}

float4 PS_pass1( float2 Tex: TEXCOORD0 ) : COLOR {
    float4 Color=tex2D(HalfToonSamp,Tex);
	float2 Tx = float2(Tex.x * offs.x, Tex.y * offs.y);
	Color *= tex2D(halfSamp, Tx) * 1.2f;
    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////

technique Gaussian <
    string Script = 
        "RenderColorTarget0=HalfToonMap;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
	    "ScriptExternal=Color;"
        "RenderColorTarget0=;"
	    "RenderDepthStencilTarget=;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
	    "Pass=Gaussian_X;"
    ;
> {
    pass Gaussian_X < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_pass1();
        PixelShader  = compile ps_3_0 PS_pass1();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
