////////////////////////////////////////////////////////////////////////////////////////////////

// ڂ̏d݌WF

float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 offs = float2(ViewportSize.x / 8.0f, ViewportSize.y / 8.0f);

// _O^[Qbg̃NAl
float4 ClearColor = {0,0,0,0};
float ClearDepth  = 1.0;

texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

texture2D HalfBaseMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {0.125,0.125};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D HalfBaseSamp = sampler_state {
    texture = <HalfBaseMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

shared texture2D HalfToon2Map : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 8;
    string Format = "A8R8G8B8" ;
>;

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;
texture2D halfmap < string ResourceName = "TV_strape.png"; >;
sampler2D halfSamp = sampler_state {
    texture = <halfmap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = WRAP;
    AddressV = WRAP;
};

////////////////////////////////////////////////////////////////////////////////////////////////
// Xڂ

struct VS_OUTPUT {
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT VS_pass1( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex;
    
    return Out;
}

float4 PS_pass0( float2 Tex: TEXCOORD0 ) : COLOR {
	return tex2D(ScnSamp, Tex + ViewportOffset);
}

float4 PS_pass1( float2 Tex: TEXCOORD0 ) : COLOR {
    float4 Color=tex2D(HalfBaseSamp,Tex);
	float2 Tx = float2(Tex.x * offs.x, Tex.y * offs.y);
	Color *= tex2D(halfSamp, Tx);
    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////

technique Gaussian <
    string Script = 
        "RenderColorTarget0=ScnMap;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
	    "ScriptExternal=Color;"

        "RenderColorTarget0=HalfBaseMap;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"Pass=CopyPass;"

        "RenderColorTarget0=HalfToon2Map;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"Pass=HalfPass;"

        "RenderColorTarget0=;"
	    "RenderDepthStencilTarget=;"
	    "Pass=CopyPass;"
    ;
> {
    pass CopyPass < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_pass1();
        PixelShader  = compile ps_3_0 PS_pass0();
    }
    pass HalfPass < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_pass1();
        PixelShader  = compile ps_3_0 PS_pass1();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
